/*jslint browser: true*/
/*global $, jQuery, alert, angular, MMRSUTILS, MMRSCLIENTGATEWAY, MMRSCONFIG, MMRSCHARTUTILS*/
var MMRSACTIONSLOG = (function () {
    "use strict";

    var mTag = "mmrsactioncreator",
        exports;

    function trace(aText) { MMRSUTILS.doTrace(mTag, aText);  }
    function note(aText) { MMRSUTILS.doTrace(mTag, aText);  }
    function warn(aText) { MMRSUTILS.doWarn(mTag, aText);   }
    function error(aText) { MMRSUTILS.doError(mTag, aText);  }
    
    angular.module('mmrsApp').controller('actioncreator', function ($scope) {
        var self = this;
        
        $scope.actionsById = {};
        $scope.SHOW_ACTON_CREATOR = "SHOW_ACTON_CREATOR";
        $scope.SHOW_PROGRESS = "SHOW_PROGRESS";
        $scope.SHOW_ACTION_CREATED = "SHOW_ACTION_CREATED";
        
        $scope.state = $scope.SHOW_ACTON_CREATOR;

        self.getActorName = function (aActor) {
            if (aActor === "REMOTE") {
                return "Call Center";
            }
            
            if (aActor === "GENIUS") {
                return "In Store";
            }
            
            if (aActor === "OWNER") {
                return "Device";
            }
            
            if (aActor === "LOCAL") {
                return "Device";
            }
            
            return aActor;
        };

        self.getStatusName = function (aStatus) {
            if (aStatus === "open") {
                return "Open";
            }
            
            if (aStatus === "resolved") {
                return "Resolved";
            }
            
            if (aStatus === "closed") {
                return "Closed";
            }
            
            return aStatus;
        };

        self.onCreateAction = function () {
            trace("onCreateAction");
            
            $scope.actionslogcontrol = $scope.SHOW_ACTON_CREATOR;
            
            $scope.formdata = {};

            $scope.formdata.newActionText2     = "";
            $scope.formdata.newActionAssignee2 = "UNASSIGNED";

            /*
            $('#actionPrompt').modal({keyboard: true}).on("hidden.bs.modal", function (aEvent)
               {
                    trace("onCreateNote, Dialog Closed");            
               }); */
        };
        
        
        function sendNewAction(aActionText, aActionAssignee) {
            trace("mmrsactioncreator: sendNewAction, Text: " + aActionText + ", Assignee: " + aActionAssignee);
            
            var update = {
                action: "update",

                fields: [
                    {
                        action: "upate",
                        field:  "actionAddText",
                        value:  aActionText
                    },
                    {
                        action: "update",
                        field:  "actionAddAssignee",
                        value:  aActionAssignee
                    }
                ]
            },
                actionUrl = "root.logger.actionadd";

            trace("sendNewAction, Sending action to device");

            // $('#actionsWait').modal('show');

            MMRSCLIENTGATEWAY.sendSetCommandToDevice(actionUrl, update, function (aRequestId, aSuccess, aResponse) {
                $scope.$apply(function () {
                    trace("sendNewAction, sendSetCommandToDevice: Success: " + aSuccess);
                    $scope.state = $scope.SHOW_ACTION_CREATED;
                });
            });
        }

        self.doActionSaveClick = function () {
            var actionText = $scope.formdata.newActionText2,
                assignee = $scope.formdata.newActionAssignee2,
                mNumOpenActions = -1;

            trace("doActionSaveClick, Text: " + actionText + ", Assignee: " + assignee);
            
            $scope.state = $scope.SHOW_PROGRESS;

            if (!actionText) {
                return;
            }

            if (assignee === "UNASSIGNED") {
                return;
            }

            // $('#actionPrompt').modal('hide');

            sendNewAction(actionText, assignee);
        };
    });


    exports = {};

    return exports;

}());