var MMRSUSERACCEPT = (function() {
"use strict"

var mIsNative    = MMRSUTILS.isNativeRun();
var DEVICEBRIDGE = MMRSUTILS.getDeviceBridge();

var mAngularScope = null;

function trace(aText) { MMRSUTILS.doTrace(exports.name, aText); }
function note(aText)  { MMRSUTILS.doTrace(exports.name, aText); }
function warn(aText)  { MMRSUTILS.doWarn (exports.name, aText); }
function error(aText) { MMRSUTILS.doError(exports.name, aText); }

var mTheApp = angular.module('app', []);

mTheApp.controller('controller', function($scope)
{
    $scope.onContinueClick = function()
    {
        trace("onContinueClick");

        var userAccepted = $scope.userAcceptCheckBox ? true : false;

        trace("onContinueClick, Accepted: " +userAccepted);

        var acceptedStr = userAccepted ? "1" : "0";

        DEVICEBRIDGE.onUserAcceptClick(acceptedStr);
    }

    $scope.doLoad = function(aOptions)
    {   
        trace(">> doLoad");

        $scope.$applyAsync(function()
        {
            // Insert any load code here
        });

        trace("<< doLoad");
    }

});
    
function showPage()
{
    trace("showPage");

    var acceptArea = document.getElementById("angularArea");
    var splashArea = document.getElementById("splashArea");

    if (acceptArea == null || splashArea == null)
    {
        return;
    }

    acceptArea.style.opacity = "1";
    splashArea.style.opacity = "0";
}

var mOptions = null;

var mMenuItems = [];

function onLoad()
{
    trace(">> onLoad");

    mAngularScope = MMRSUTILS.getAngularScope("angularArea");

    if (mAngularScope == null)
    {
        error("doLoad, Could not find angular scope area");
        return;
    }

    mAngularScope.doLoad();

    trace("onLoad, Starting Timer");

    setTimeout(showPage, 2000);    

    trace("<< onLoad");    
}

var exports = {};

exports.name    = "mmrsuseraccept";

exports.onLoad  = function(aOptions) { onLoad(); }

return exports;

}());
