var MMRSWELCOME = (function() {
"use strict"

var mIsNative  = MMRSUTILS.isNativeRun();

var DEVICEBRIDGE = MMRSUTILS.getDeviceBridge();

var mAngularScope = null;

function trace(aText) { MMRSUTILS.doTrace(exports.name, aText); }
function note(aText)  { MMRSUTILS.doTrace(exports.name, aText); }
function warn(aText)  { MMRSUTILS.doWarn (exports.name, aText); }
function error(aText) { MMRSUTILS.doError(exports.name, aText); }

var mTheApp = angular.module('app', []);

mTheApp.controller('controller', function($scope)
{
    $scope.menuItems =
    [
        //{ title: "Data Back up",   comment: "Back up or restore your data",                 icon: "images/thumb_back_up.png",       action: "backup"        },
        { title: "Diagnostic",     comment: "Check your phone for potential problems",      icon: "images/thumb_diagnostic.png",    action: "localcheck"    },
        { title: "Remote access",  comment: "Allow a remote agent to access your device",  icon: "images/thumb_remote_access.png", action: "remotecheck"   },
        { title: "Hardware tests", comment: "Run hardware tests",                           icon: "images/thumb_diagnostic.png",    action: "hardwaretests" }        
    ];

    $scope.onMenuButtonClick = function(aAction)
    {
        trace("onMenuButtonClick, Action: " +aAction);

        DEVICEBRIDGE.onMenuButtonClick(aAction);
    }

    $scope.doLoad = function(aOptions)
    {   
        trace(">> doLoad");

        $scope.$applyAsync(function()
        {
            // Insert any load code here
        });

        trace("<< doLoad");
    }

});
    
var mOptions = null;

var mMenuItems = [];

function onLoad()
{
    trace(">> onLoad");

    mAngularScope = MMRSUTILS.getAngularScope("angularArea");

    if (mAngularScope == null)
    {
        error("doLoad, Could not find angular scope area");
        return;
    }

    mAngularScope.doLoad();

    trace("<< onLoad");    
}

var exports = {};

exports.name    = "mmrswelcome";

exports.onLoad  = function(aOptions) { onLoad(); }

return exports;

}());
