var MMRSHOME = (function() {
	"use strict"

var mIsNativeRun = MMRSUTILS.isNativeRun();

var BRIDGE = MMRSUTILS.getDeviceBridge();

function trace(aText) { MMRSUTILS.doTrace(exports.name, aText); }
function warn(aText)  { MMRSUTILS.doWarn (exports.name, aText); }
function error(aText) { MMRSUTILS.doError(exports.name, aText); }

var EOR = String.fromCharCode(10);

window.onerror = function(aMessage) { error(aMessage); }

var mTheApp = angular.module('aApp', []);

mTheApp.controller('aController', function($scope)
{
    var HOME_PAGE = "mmrshome.html?background=WelcomeBackground&hideNavBar=true&isHome=true";
    var HOME_PAGE = "mmrshome.html?background=backgroundwelcome3&hideNavBar=true&isHome=true";

    var EXCHANGE_PRICES_TEST = ["", "1000", "2000", "3000"];

    var MSISDN       = "01234567890";
    var DEVICE_IMEI  = "111111111111110";
    var ACCOUNT_IMEI = "111111111111110";
    var ACCOUNT_IMEI = "222222222222220";

    var CONTRACT_DATE_PROPERTY          = "accountContractStartDate";
    var SELF_ASSESSMENT_REPORT_PROPERTY = "UserReportSwapAssessment";

    var mStopHomePageLaunch = false;

    $scope.menuItems = 
    [
        {
            action:  "clear-assessment",
            icon:    "images/icondevice.png",                
            title:   "Delete Self Assessment & Swap Prices",
            comment: "Remove the previous self assessment",
        },         
        {
            action:  "notlease",
            icon:    "images/icondevice.png",                
            title:   "Not on lease plan",
            comment: "Transfer, backup or restore content",
        },       
        {
            action:  "evergreen1",
            icon:    "images/icondevice.png",                
            title:   "Evergreen Only: Year 1",
            comment: "Transfer, backup or restore content",
        },
        {
            action:  "assure1",                        
            icon:    "images/icondevice.png",                
            title:   "Evergreen + Assue: Year 1",
            comment: "Self-Care"
        },
        {
            action:  "evergreen2",            
            icon:    "images/icondevice.png",                
            title:   "Evergreen Only: Year 2",
            comment: "Assisted Care"
        },
        {
            action:  "assure2",                        
            icon:    "images/icondevice.png",                
            title:   "Evergreen + Assure: Year 2",
            comment: "Swap Lease"
        },
        {
            action:  "evergreen30",                        
            icon:    "images/icondevice.png",                
            title:   "Evergreen Only: 30 Months+",
            comment: "Swap Lease"
        },
        {
            action:  "assure30",                        
            icon:    "images/icondevice.png",                
            title:   "Evergreen + Assure: 30 Months+",
            comment: "Swap Lease"
        } 
    ];

    var mSwapMenuItemIndex = 3;


    $scope.onMenuItemClick = function(aItem)
    {
        trace("onMenuItemClick, Item: " +aItem.title+ ", Action: " +aItem.action);

        BRIDGE.setValue("msisdn",      MSISDN);
        BRIDGE.setValue("imei",        DEVICE_IMEI);
        BRIDGE.setValue("accountIMEI", ACCOUNT_IMEI);

        var action = aItem.action;

        if (action == "clear-assessment")
        {
            BRIDGE.writePage(SELF_ASSESSMENT_REPORT_PROPERTY, "");
            BRIDGE.setValue("ExchangePrices", "");
            return;
        }

        if (action == "notlease")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2017-05-26T09:50:00")); // Year 1

            BRIDGE.setValue("accountProducts",     "INTL_ROAMING,INTL_DAY_PASS");
            BRIDGE.setValue("accountOnLeasePlan",  "false");
            BRIDGE.setValue("accountOnAssurePlan", "false");
            BRIDGE.setValue("optionAllowSwap",     "false");            

            launchHomeScreen();
            return;
        }

        if (action == "evergreen1")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2019-07-20T10:30:00")); // Year 1

            BRIDGE.setValue("accountProducts",     "INTL_ROAMING,SHARED_DATA_PACK,INTL_DAY_PASS,OTHER");

            BRIDGE.setValue("accountOnLeasePlan",  "true");
            BRIDGE.setValue("accountOnAssurePlan", "false");
            BRIDGE.setValue("optionAllowSwap",     "true");            

            launchHomeScreen();
            return;            
        }

        if (action == "assure1")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2019-07-21T11:30:00")); // Year 1

            BRIDGE.setValue("accountProducts",     "MOBILE_SWAP_ASSURE,INTL_ROAMING,INTL_DAY_PASS");
            BRIDGE.setValue("accountOnLeasePlan",  "true");
            BRIDGE.setValue("accountOnAssurePlan", "true");
            BRIDGE.setValue("optionAllowSwap",     "true");            

            launchHomeScreen();
            return;            
        }

        if (action == "evergreen2")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2018-06-20T12:30:00")); // Year 2

            BRIDGE.setValue("accountProducts",    "INTL_ROAMING,INTL_DAY_PASS,OTHER");            
            BRIDGE.setValue("accountOnLeasePlan",  "true");
            BRIDGE.setValue("accountOnAssurePlan", "false");
            BRIDGE.setValue("optionAllowSwap",     "true");            

            launchHomeScreen();
            return;              
        }

        if (action == "assure2")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2018-06-20T13:30:00")); // Year 2

            BRIDGE.setValue("accountProducts",     "MOBILE_SWAP_ASSURE_0,INTL_ROAMING");            
            BRIDGE.setValue("accountOnLeasePlan",  "true");
            BRIDGE.setValue("accountOnAssurePlan", "true");
            BRIDGE.setValue("optionAllowSwap",     "true");            

            launchHomeScreen();
            return;            
        }

        if (action == "evergreen30")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2015-01-20T14:30:00")); // Year 2

            BRIDGE.setValue("accountProducts",     "INTL_ROAMING,INTL_DAY_PASS,OTHER");
            
            BRIDGE.setValue("accountOnLeasePlan",  "true");
            BRIDGE.setValue("accountOnAssurePlan", "false");
            BRIDGE.setValue("optionAllowSwap",     "true");            

            launchHomeScreen();
            return;            
        }

        if (action == "assure30")
        {
            BRIDGE.setValue(CONTRACT_DATE_PROPERTY, epocTime("2015-02-20T15:30:00")); // Year 2

            BRIDGE.setValue("accountProducts",     "MOBILE_SWAP_ASSURE_0,INTL_ROAMING");
            
            BRIDGE.setValue("accountOnLeasePlan",  "true");
            BRIDGE.setValue("accountOnAssurePlan", "true");
            BRIDGE.setValue("optionAllowSwap",     "true");            

            launchHomeScreen();
            return;            
        }
    }

    function launchHomeScreen()
    {
        trace("launchHomeScreen");

        if (!mStopHomePageLaunch)
        {
            window.location.href = HOME_PAGE;
        }
    }    

    function epocTime(aDate)
    {
        var time = Date.parse(aDate);

        if (time == null || isNaN(time))
        {
            error("unixDate, Bad Date: " +aDate);
            return 0;
        }

        time = Math.floor(time/1000);
 
        return time;
    }


    //====================================================================================
    // Which App Services to Try/Enable
    //====================================================================================
    //
    var mRequestHostUrl  = null;

    function fetchServices()
    {
        var servicesFile = BRIDGE.getValue("services-file");

        if (servicesFile == null || servicesFile == "")
        {
            servicesFile = "servicesweb.json";
        }

        var url = mRequestHostUrl + servicesFile;

        trace("fetchServices, Url: " +url);

        BRIDGE.fetchUrl(url, onServicesReceived); 
    }    

    function onServicesReceived(aUrl, aSuccess, aHeader, aText)
    {
        trace(">> onServicesReceived, Success: " +aSuccess);

        if (! aSuccess)
        {
            error("onServicesReceived, Unable to fetch services");
            return;
        }

        trace("onServicesReceived, Services: " +aText);

        var services = null;

        try
        {
            services = JSON.parse(aText);
        }
        catch(err)
        {
            error("onServicesReceived, Json: " +err);
            services = null;
        }

        if (services == null)
        {
            error("onServicesReceived, Could not decode services");
            return;
        }

        saveServicesValues(services);

        fetchFAQText();

        trace("<< onServicesReceived");        
    } 

    function saveServicesValues(aServices)
    {
        if (aServices == null || aServices.values == null)
        {
            return;
        }

        var values = aServices.values;

        for (var thisKey in values)
        {
            var thisValue = values[thisKey];

            trace("saveServicesValues, Key: " +thisKey+ ", Value: " +thisValue);
            BRIDGE.setValue(thisKey, thisValue);
        }
    }


    //====================================================================================
    // Assessment Report
    //====================================================================================
    //
    function fetchAssessmentReport(aIMEI)
    {
        trace(">> fetchAssessmentReport, IMEI: " +aIMEI);

        BRIDGE.writePage(SELF_ASSESSMENT_REPORT_PROPERTY, "");

        NETSERVICES.fetchAssessmentReport(aIMEI, function(aSuccess, aResponse)
        {
            trace("fetchAssessmentReport, Success: " +aSuccess+ ", Response: " +aResponse);

            var response = null;
            
            try
            {
                response = JSON.parse(aResponse);
            }
            catch(err)
            {
                trace("fetchAssessmentReport, Could not parse response: " +aResponse);
                response = null;
            }

            if (response == null || response.retrieveDeviceAssessmentResponse == null)
            {
                trace("fetchAssessmentReport, No report stored");
                return;
            }

            var report = response.retrieveDeviceAssessmentResponse;

            report.swapPrice = report.aux1;

            var reportStr = JSON.stringify(report);

            BRIDGE.writePage(SELF_ASSESSMENT_REPORT_PROPERTY, reportStr);

            trace("fetchAssessmentReport, Report saved locally");

        });

    }


    //====================================================================================
    // Download Swap FAQs
    //====================================================================================
    //
    function fetchFAQText()
    {
        //trace("fetchFAQText");

        var url = BRIDGE.getValue("swapFAQUrl");

        if (url == null || url == "")
        {
            warn("fetchFAQText, No FAQ Text URL");            
            //launchHomeScreen();
            return;            
        }

        url = getRequestUrl(url);

        if (url == null)
        {
            warn("fetchFAQText, Bad URL");
            launchHomeScreen();
            return;            
        }        

        BRIDGE.fetchUrl(url, onFAQTextReceived); 
    }

    function onFAQTextReceived(aUrl, aSuccess, aHeader, aText)
    {
        trace("onFAQTextReceived, Success: " +aSuccess);
        trace("onFAQTextReceived, Text: " +aText);

        if (! aSuccess)
        {
            return;
        }

        BRIDGE.writePage("swap-faqs", aText);
    }

    function getRequestUrl(aUrl)
    {
        if (aUrl == null)
        {
            warn("getRequestUrl, Url is null");            
            return null;
        }        

        if (aUrl.substr(0, 4) == "http")
        {
            return aUrl;
        }

        var relativeUrl = mRequestHostUrl + aUrl;

        return relativeUrl;
    }

    ///////////////////////////////////////////////////////////////////////////////////////

 	$scope.doLoad = function()
    {   
	    trace(">> doLoad");

        if (! mIsNativeRun)
        {
            //localStorage.clear();
        }        

        BRIDGE.setValue("ExchangePricesTest", JSON.stringify(EXCHANGE_PRICES_TEST));

        mRequestHostUrl = BRIDGE.getRequestHostUrl() + "/" +BRIDGE.getParam("deviceDir") + "/";

        fetchServices(); 

        fetchAssessmentReport(MSISDN);

	    trace("<< doLoad");
	}

    $scope.doLoad();
});
 
function onLoad()
{
}

var exports = {};

exports.name = "mmrshome";

exports.onLoad = function(aOptions) { onLoad(aOptions); }

return exports;

}());
