var CARROUSEL_CHOICE_DIRECTIVE = (function()
{
    "use strict";

    mTheApp.directive('itemCarrousel',  CarrouselDirective);

    var mScope = null;

    var mSelectedChoice = null;

    function CarrouselDirective()
    {
        return {
            link: function(scope)
            {
                console.log("CarrouselChoiceDirective - link");

                mScope = scope;

                scope.onCarrouselChoice = function(aChoice)
                {
                    doCarrouselChoice(aChoice);
                    scope.detail = aChoice.detail;
                }
            },
            replace: true,
            restrict: 'E',
            scope: {
                item: '=',
                onChoiceSelected: '='
            },
            template: '' +
                '<div class="carrouselRow {{ item.cssClass }}">' +
                '    <table class="carrousel" ng-hide="item.hide">' +
                '        <tr>' +
                '            <td' +
                '                class="carrousel {{choice.selected}}"' +
                '                ng-repeat-start="choice in item.choices track by $index"' +
                '                ng-click="onCarrouselChoice(choice)"' +
                '            >' +
                '                <div class="carrouselChoice">' +
                '                    <img class="carrouselImage" ng-src="{{ choice.image }}" />' +
                '                    <div class="carrouselTitle" ng-bind="choice.text"></div>' +
                '                </div>' +
                '            </td>' +
                '            <td class="carrouselSpacer" ng-repeat-end ng-if="!$last"></td>' +
                '        </tr>' +
                '    </table>' +
                '    <div ng-show="detail" id="carrouselDetail" class="carrouselDetail" ng-bind="detail"></div>' +
                '</div>'
        }
    }

    function doCarrouselChoice(aChoice)
    {
        console.log("doCarrouselChoice:", aChoice);

        if (mSelectedChoice != null)
        {
            mSelectedChoice.selected = "";
        }

        mSelectedChoice = aChoice;

        mScope.onChoiceSelected(aChoice);

        aChoice.selected = "selected";
    }

})();
