var TEST_PIXELS_DIRECTIVE = (function()
{
  "use strict";

  mTheApp.directive('itemTestPixels',  PixelsTestDirective);

  var mIsNative = MMRSUTILS.isNativeRun();

  var DEVICEBRIDGE = MMRSUTILS.getDeviceBridge();

  var mScope    = null;
  var mTestArea = null;

  function PixelsTestDirective() {
    return {
        restrict: 'E',
        scope: {
            item: '=',
            onTestComplete: '='
        },
        replace: true,
        templateUrl: 'directives/item-test-pixels.html',

        link: function(scope, element, attrs)
        {      
            console.log("PixelsTestDirective - link");

            mScope = scope;
            mTestArea = getTestArea(element);
   
            initialiseTest();
        }
    }
  }


  function getTestArea(aElements)
  {
      if (aElements == null || aElements.length == 0)
      {
          console.log("getTestArea-  No elements");
          return null;          
      }

      var area = aElements[0];

      if (area == null)
      {
          console.log("getTestArea - No children elements");
          return null;
      }

      return area;
  }

  function getTimeNow()
  {
      var dateNow = new Date();
      var timeNow = dateNow.getTime();
      return timeNow;
  }

  function initialiseTest()
  {  
      //mScope.color = 'yellow';

      //mScope.style2 = { backgroundColor : "blue", opacity: "0.5" };

      setTimeout(onColourChange, 1500);

      //aTestArea.style.opacity = "1";     
  }  

  var mColours     = ["red", "green", "blue"]; //, "blue", "green", "yellow", "black"];
  var mColourIndex = 0;

  function onColourChange()
  {
      console.log("onColourChange");

      mScope.$applyAsync(function()
      {
          var thisColour = mColours[mColourIndex];

          if (thisColour == null)
          {
              mTestArea.style.display = "none";
              mScope.onTestComplete(mTestArea);              
              return;
          }

          mColourIndex++;

          mScope.style = { backgroundColor : thisColour, opacity: "1" };    

          setTimeout(onColourChange, 2000);
      });
  }

})();
