var SRWF_DIRECTIVES = (function()
{
  "use strict";

  //mTheApp.constant('PageItemTypes', PageItemTypesConstant());
  //mTheApp.directive('itemText',          TextDirective);

  mTheApp.directive('itemHeadingIcon',      HeadingIconDirective);
  mTheApp.directive('itemHeadingText',      HeadingTextDirective);
  mTheApp.directive('itemSubheadingText',   SubheadingTextDirective);
  mTheApp.directive('itemMainheadingText',  MainheadingTextDirective);

  mTheApp.directive('itemPriceText',        PriceTextDirective);

  mTheApp.directive('itemQueryText',        QueryTextDirective);

  mTheApp.directive('itemCheckChoice',      CheckChoiceDirective);
  mTheApp.directive('itemListNumbered',     ListNumberedDirective);
  mTheApp.directive('itemListBullet',       ListBulletDirective);

  mTheApp.directive('itemButtonText',       TextButtonDirective);
  mTheApp.directive('itemButtonLink',       LinkButtonDirective);
  mTheApp.directive('itemButtonYes',        YesButtonDirective);
  mTheApp.directive('itemButtonNo',         NoButtonDirective);
  mTheApp.directive('itemButtonRetry',      RetryButtonDirective);

  mTheApp.directive('itemText',             TextDirective);

  mTheApp.directive('itemStepper',          StepperDirective);

  // HEADING
  //
  function HeadingIconDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-heading-icon.html'
    }
  }

  // HEADING
  //
  function HeadingTextDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-heading-text.html'
    }
  }

  // SUB-HEADING
  //
  function SubheadingTextDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-subheading-text.html'
    }
  }

  // MAINHEADING
  //
  function MainheadingTextDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-mainheading-text.html'
    }
  }

  // PRICE TEXT
  //
  function PriceTextDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-price-text.html'
    }
  }  

  // CHECK-CHOICE
  //
  function CheckChoiceDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-check-choice.html'
    }
  }

  // LISTS
  //
  function ListNumberedDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-list-numbered.html'
    }
  }

  function ListBulletDirective() {
    return {
      controller: function ($compile, $element, $scope)
      {
        this.$onInit = function () {
            if ($scope.item.onClick)
            {
                var template = getBulletListTemplate($scope.item.items);                
                $element.replaceWith($compile('<div>' + template + '</div>')($scope));
            }
        }
      },
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      template: '' +
        '<div class="listBullet">' +
        ' <ul class="listBullet">' +
        '   <li class=listBulletItem ng-repeat="listItem in item.items">'  +
        '     <DIV class="listBulletTitle">{{listItem}}</DIV>' +
        '   </li>' +
        ' </ul>' +
        '</div>'
    }
  }  

  function getBulletListTemplate(aListItems)
  {
      console.log("getBulletListTemplate");
      
      var template = '<ul class="listBullet">';


      for (var index in aListItems)
      {
          var thisItem = aListItems[index];

          var placeholderStart = '\\[#';
          var placeholderStartLength = 2;
          var placeholderEnd = '#]';
          var placeholderEndLength = 2;

          var regEx = new RegExp('(?:' + placeholderStart + ')((?!' + placeholderEnd + ').)*(?:' + placeholderEnd + ')', 'g');

          var thisItemTemplate = thisItem.replace(regEx, function (match)
          {
              var placeholderData = match.substring(placeholderStartLength, match.length - placeholderEndLength).split('|');

              var label   = placeholderData[0];
              var key     = placeholderData[1];
                            
              var result = '<A ng-click="item.onClick(\'' +key+ '\')">';

              result += '' +label+ '</A>';

              console.log("getBulletListTemplate, Result: ");

              console.log(result);

              return result
          });      

          template += "<li class='listBulletItem'>";

          template += "<div class='listBulletTitle'>" +thisItemTemplate+ "</div>";

          template += "</li>";

      }

      template += "</ul>";

      console.log(template);

      return template;  
  }



  // QUERY TEXT
  //
  function QueryTextDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-query-text.html'
    }
  }

  // TEXT-BUTTON
  //
  function TextButtonDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-button-text.html'
    }
  }

  // LINK-BUTTON
  //

  function LinkButtonDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-button-link.html'
    }
  }
  
    function TextDirective() {
        return {
            controller: function ($compile, $element, $scope) {
                this.$onInit = function () {
                    if ($scope.item.onClick) {
                        var placeholderStart = '\\[#';
                        var placeholderStartLength = 2;
                        var placeholderEnd = '#]';
                        var placeholderEndLength = 2;

                        var regEx = new RegExp('(?:' + placeholderStart + ')((?!' + placeholderEnd + ').)*(?:' + placeholderEnd + ')', 'g');

                        var template = $scope.item.text.replace(regEx, function (match) {
                            var tag;
                            var cssClass;

                            var placeholderData = match.substring(placeholderStartLength, match.length - placeholderEndLength).split('|');
                            var label = placeholderData[0];
                            var key = placeholderData[1];
                            var variant = placeholderData[2];

                            switch(variant) {
                                case 'BUTTON': {
                                    tag = 'div';
                                    cssClass = 'bottomButton';
                                } break;
                                default: {
                                    tag = 'a';
                                    cssClass = '';
                                }
                            }

                            var result = '<' + tag + ' ng-click="item.onClick(\'' + key + '\')"' + (cssClass ? ' class="' + cssClass + '"' : '') + '>'
                                + label
                                +'</' + tag + '>';

                            return result
                        });

                        $element.append($compile('<div>' + template + '</div>')($scope));
                    }
                }
            },
            replace: true,
            restrict: 'E',
            scope: {
                item: '=',
                align: '@',
                cssClass: '@'
            },
            template: '' +
                '<div' +
                '    class="flowText {{ cssClass ? \'flowText--\' + cssClass : \'\' }}"' +
                '    id="{{ item.id }}"' +
                '    ng-class="{' +
                '        \'flowText--left\': align === \'left\',' +
                '        \'flowText--center\': align === \'center\' || !align,' +
                '        \'flowText--right\': align === \'right\'' +
                '    }"' +
                '>' +
                '    <div' +
                '        ng-if="!item.onClick"' +
                '        ng-bind-html="item.text"' +
                '    ></div>' +
                '</div>'
        }
    }

  // YES-BUTTON
  //
  function YesButtonDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-button-yes.html'
    }
  }

  // No-BUTTON
  //
  function NoButtonDirective() { // As in yes/no - not missing button
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-button-no.html'
    }
  }

  // Retry-BUTTON
  //
  function RetryButtonDirective() { // As in yes/no - not missing button
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-button-retry.html'
    }
  }

  // Stepper
  //
  function StepperDirective() {
    return {
      restrict: 'E',
      scope: {
        item : '='
      },
      replace: true,
      templateUrl: 'directives/item-stepper.html'
    }
  }

})();
