<script type="workflow-page">
	
	var PROPERTY = Properties.CaseStatus;
	
	var page =
	{
	    items:
	    [
			{
				type:  "HEADINGICON",
				value: "images/icon-case.png"
			},	    
			{
				type: "HEADING",
				text: "Body Damage"
			},
			{
				type: "SUBHEADING",
				text: "How best would you describe the physical condition of your device's body?"
			},
			{
				type: "CARROUSEL",
				choices:
				[
					{
						value: 		Const.CONDITION_GOOD,
						image: 		"images/device-case-good.png",
						text: 		"As new",
						detail:     "Minimal scratches, no dents or cracks",	
						appState: 	MMRSAPPSTATE.EVERGREEN_CASE_CHECK_GOOD
					},
					{
						value: 		Const.CONDITION_MINOR_DAMAGE,
						image: 		"images/device-wear-tear.png",
						text:  		"General wear & tear",
						detail:     "Scratches and marks on body consistent with daily use",
						appState: 	MMRSAPPSTATE.EVERGREEN_CASE_CHECK_MODERATE						
					},
					{
						value: 		Const.CONDITION_MAJOR_DAMAGE,
						image: 		"images/device-case-damage.png",
						text:  		"Damaged",
						detail:     "Deep scratches, cracked body, bent phone",
						appState: 	MMRSAPPSTATE.EVERGREEN_CASE_CHECK_BAD						
					}
				],
				onClick: onCarrouselClick			
			}			
		],

	    navigationItems:
	    [
			{
				id:   "next",
				type: "TEXT",
				text: "Next",
				onClick: onNextClick,
				hide: true
			}		
      	]
	};

	var mAppState = null;

	function onCarrouselClick(aChoice)
	{
		console.log("onCarrouselClick: " +aChoice.value);

		setTimeout(WorkflowUtils.scrollTo, 500, "carrouselDetail");		

		mAppState = aChoice.appState;

		var level    = aChoice.value - 0;
		var reported = level;

		if (level == Const.CONDITION_MINOR_DAMAGE)
		{
			level = Const.CONDITION_GOOD; // For cost calculation, General Wear & Tear is treated as GOOD
		}
		
		var status = JSON.stringify({ details: aChoice.text, level: level, reported: reported});

		Workflow.setProperty(PROPERTY, status);

		var navItems = Workflow.getNavigationItems();

		Workflow.setVisibility(navItems[0], true);
	}

	function onNextClick()
	{
		Workflow.setAppState(mAppState);

		Workflow.popPage();
	}

</script>

