<script type="workflow-page">
	
	var page =
	{
	    items:
	    [	    
			{
				type: "HEADING",
				text: "Your lease plan"
			},
			{
				type: "SUBHEADING",
				text: "You started leasing this device, under a <B>Mobile lease plan</B>, on " +
					  "<B>" +getContractStartDate()+ "</B>."
			},
			{
				type:    "FAQ",
				items:   getFAQItems(),
				onClick: onFAQClick						
			},
			{
				type: "SUBHEADING",
				text: "<B>You'll be able to upgrade to a new device on " +getSwapStartDate()+
				       " when you take up a new plan with an eligible 24 / 36 month device payment.</B>"
			},			
			{
				type:  "TEXT-LEFT",
				align: 'left',
				text:  "To discuss your options:"
			},
			{
				type: "LIST-BULLET",
				onClick: onOptionClick,
				items:
				[
					"Chat to us on [#Telstra 24x7 Chat|xhttps://www.telstra.com.au/chatnow/landing#]",
					"Call us 24/7 on [#13 22 00|tel:132200#]",
					"Visit a [#Telstra store|xhttps://www.telstra.com.au/telstra-store#]"
				]
			}			
		],

	    navigationItems:
	    [
			{
				type: "TEXT",
				text: "Done",
				onClick: onNextClick,
			}	
      	]
	};

	function init()
	{
	}	

	function getFAQItems()
	{
		var faqsString = Workflow.readValue("swap-faqs");

		var faqs = [];

		try
		{
			faqs = JSON.parse(faqsString);
		}
		catch (err)
		{
			console.log("getFAQItems, Exception: " +err);
		}

		return faqs;
	}

	function getContractStartDate()
	{
		var contractTime = Workflow.getProperty(Properties.accountContractStartDate);
		
		var contractDate = new Date(contractTime*1000);

		var contractStr  = WorkflowUtils.makeShortDateString(contractDate);

		return contractStr;		
	}

	function getSwapStartDate()
	{
		var contractTime  = Workflow.getProperty(Properties.accountContractStartDate);
		
		var swapStartDate = new Date(contractTime*1000);

        swapStartDate.setFullYear(swapStartDate.getFullYear() + 1);        

		var swapStartStr  = WorkflowUtils.makeShortDateString(swapStartDate);

		return swapStartStr;
	}
	
	function onNextClick()
	{
		console.log("onNextClick");
		Workflow.popPage();
	}

	function onFAQClick(aItem, aExpanded, aHeaderId)
	{
		console.log("onFAQClick, Item: " +aItem.id+ ", Header: " +aHeaderId);	

		if (!aExpanded)
		{
			return;
		}

		WorkflowUtils.scrollTo(aHeaderId);
	}	

	function onOptionClick(aOption)
	{
		console.log("onOptionClick, Option: " +aOption);

		window.location.href = aOption;		
	}

</script>

