<script type="workflow-page">
	
	var page =
	{
	    items:
	    [    
			{
				type: "HEADING",
				text: "Your lease plan"
			},
			{
				type: "SUBHEADING",
				text: "Your lease has ended and you now own your device."
			},			
			{
				type: "SUBHEADING",
				text: getContractText()
			},
			{
				type:    "FAQ",
				items:   getFAQItems(),
				match:   getFAQMatches(),				
				onClick: onFAQClick						
			},
			{
				type:  "TEXT-LEFT",
				align: 'left',
				text:  "To discuss your options:"
			},
			{
				type: "LIST-BULLET",
				onClick: onOptionClick,
				items:
				[
					"Chat to us on [#Telstra 24x7 Chat|xhttps://www.telstra.com.au/chatnow/landing#]",
					"Call us 24/7 on [#13 22 00|tel:132200#]",
					"Visit a [#Telstra store|xhttps://www.telstra.com.au/telstra-store#]"
				]
			}				
		]
	};
	
	function init()
	{
	}	 

	function getFAQItems()
	{
		var faqsString = Workflow.readValue("swap-faqs");

		var faqs = [];

		try
		{
			faqs = JSON.parse(faqsString);
		}
		catch (err)
		{
			console.log("getFAQItems, Exception: " +err);
		}

		return faqs;
	}

	function getFAQMatches()
	{
		var onAssure = Workflow.getProperty(Properties.accountOnAssurePlan) == "true";
		
		var match = onAssure ? ["MOBILE_SWAP_ASSURE"] : null;

		return match;
	}

	function getContractText()
	{
		var onAssure = Workflow.getProperty(Properties.accountOnAssurePlan) == "true";

		var text = "You started leasing this device, under a <B>Mobile Lease Plan</B>, on ";

		if (onAssure)
		{
			text = "You started leasing this device, under a <B>Mobile Lease Plan</B>, " +
			       "with <B>Mobile Swap Assure</B> on ";
		}

		text += "<B>" +getContractStartDate()+ "</B>.";

		return text;
	}

	function getContractStartDate()
	{
		var contractTime = Workflow.getProperty(Properties.accountContractStartDate);
		
		var contractDate = new Date(contractTime*1000);

		var contractStr  = WorkflowUtils.makeShortDateString(contractDate);

		return contractStr;		
	}	

	function onFAQClick(aItem, aExpanded, aHeaderId)
	{
		console.log("onFAQClick, Item: " +aItem.id+ ", Header: " +aHeaderId);	

		if (!aExpanded)
		{
			return;
		}

		WorkflowUtils.scrollTo(aHeaderId);
	}	

	function onOptionClick(aOption)
	{
		console.log("onOptionClick, Option: " +aOption);

		window.location.href = aOption;		
	}

</script>

