<script type="workflow-page">
	
	var PROPERTY = Properties.LiquidStatus;

	var page =
	{
	    items:
	    [
			{
				type:  "HEADINGICON",
				value: "images/icon-liquid.png"
			},	    
			{
				type: "HEADING",
				text: "Liquid Damage"
			},
			{
				type: "SUBHEADING",
				text: "Does the device show signs of rust or corrosion " +
				      "in the earphone jack, SIM card slot, or power port? " +
				      "Are there signs of condensation in the screen or camera lens?"
			},			
			{
				type: "CARROUSEL",
				choices:
				[
					{
						value: 		Const.CONDITION_GOOD,
						image: 		"images/device-as-new.png",
						text: 		"No liquid damage",
						appState: 	MMRSAPPSTATE.EVERGREEN_LIQUID_CHECK_GOOD
					},
					{
						value: 	Const.CONDITION_MAJOR_DAMAGE,
						image: 	"images/device-liquid-damage.png",
						text: 	 "Liquid damage",
						appState: 	MMRSAPPSTATE.EVERGREEN_LIQUID_CHECK_BAD						
					}
				],
				onClick: onCarrouselClick			
			}			
		],

	    navigationItems:
	    [
			{
				id:   "next",
				type: "TEXT",
				text: "Next",
				onClick: onNextClick,
				hide: true
			}	
      	]
	};

	var mAppState = null;
	
	function onCarrouselClick(aChoice)
	{
		console.log("onCarrouselClick, Condition: " +aChoice.value);

		mAppState = aChoice.appState;

		var status = JSON.stringify({ details: aChoice.text, level: aChoice.value });

		Workflow.setProperty(PROPERTY, status);

		var navItems = Workflow.getNavigationItems();

		Workflow.setVisibility(navItems[0], true);
	}

	function onNextClick()
	{
		Workflow.setAppState(mAppState);

		Workflow.popPage();
	}

</script>

