<script type="workflow-page">

    var ANDROID_LOCKS_URL = "xhttps://support.google.com/nexus/answer/2840815?hl=en";
    var iPHONE_LOCKS_URL  = "xhttps://support.apple.com/en-au/HT201441";

    var mChatHowTo = {
        title: "<b>Chat to us</b>",
        id: "howto-chat",
        text:
            "<p><b>Step 1.</b> Start a [#Live Chat session|chat#]" +
            "<p><b>Step 2.</b> Choose your new device on a new 24 month plan." +
            "<p><b>Step 3.</b> We’ll send out your new device and a satchel to return your old one." +
            "<p><b>Step 4.</b> Backup your old device, remove the SIM and turn off any activation locks, " +
                "such as <b>Google Accounts</b> or <b>Find my iPhone</b>. " +
                "[#See how to turn off activation locks|locks#]" +
            "<p><b>Step 5.</b>  Return your old device to us within 14 days.",
        onClick: onLinkClick
    };

    var mStoreHowTo = {
        title: "<b>Visit a Telstra store</b>",
        id: "howto-store",
        text:
            "<p><b>Step 1.</b> Backup your device" +
            "<p><b>Step 2.</b> Go to a Telstra store within 7 days of completing the device test." +
            "<p><b>Step 3.</b> Remove the SIM and turn off any activation locks, " +
                "such as <b>Google Accounts</b> or <b>Find my iPhone</b>. " +
                "[#See how to turn off activation locks|locks#]" +
            "<p><b>Step 4.</b> We’ll check your old device in-store to ensure the upgrade fee is correct." +
            "<p><b>Step 5.</b> Pay the upgrade fee and enter a new 24 month Go Mobile Swap lease plan." +
            "<p><b>Step 5.</b> Exchange your old device for a new one.",
        onClick: onLinkClick
    };

    var page = {
        items: [
            {
                type: "HEADING",
                text: "How to upgrade"
            },
            {
                type : "TEXT-LEFT",
                text : "Continue on Telstra.com to upgrade your device."
            },
            {
                type: "STEPPER",
                items: [
                    { text: "Login for an express checkout or proceed as a guest." },
                    { text: "Select your current service." },
                    { text: "Complete the checkout steps." },
                    { text: "We'll send out your new device and a satchel to return your old one." },
                    {
                        text: "Backup your old device, remove the SIM " +
                              "and turn off any activation locks, such as " +
                              "<b>Google Accounts</b> or <b>Find my iPhone</b>. " +
                              "[#See how to turn off activation locks|locks#]",
                        onClick: onLinkClick
                    },
                    { text: "Return your old device to us within 14 days." }
                ]
            },
            {
                type: "TEXT",
                text: "[#Continue on Telstra.com <img src='images/icon-external-link.png' style='height: 19px; margin: 0 0 -2px 5px;' />||BUTTON#]",
                onClick: onTelstraClick
            },
            {
                type: "TEXT",
                text: "or"
            },
            {
                type: "FAQ",
                items: [mChatHowTo, mStoreHowTo]
            },
            {
                type: "TEXT",
                text: "[#Return to the main menu|home#]<br /><br />Got question? Call us 24x7 on [#13 22 00|dial#]",
                onClick: onNavClick
            }
        ],

        navigationItems: [
        ]
    };

    function onNavClick(aOption)
    {
        if (aOption == "home")
        {
            Workflow.popToHomePage();
        }
        else
        {
            window.location.href = "tel:132200";
        }
    }

    function onLinkClick(aOption)
    {
        if (aOption == "chat")
        {
            window.location.href = Const.TELSTRA_CHAT_URL;            
            return;
        }

        if (aOption == "locks")
        {
            var link = WorkflowUtils.isAndroidRun() ? ANDROID_LOCKS_URL : iPHONE_LOCKS_URL;
            window.location.href = link;
            return;            
        }

        console.log("onLinkClick, Unexpected Option: " +aOption);
    }

    function onTelstraClick()
    {
        window.location.href = "xhttp://www.telstra.com";
    }

</script>
