<script type="workflow-page">
	
	var TEST_TEXT_PASSED = "No dead pixels observed";
	var TEST_TEXT_FAILED = "Dead pixels observed";

	var PROPERTY = Properties.PixelStatus;

	var page =
	{
	    items:
	    [
			{
				type: "TEST_PIXELS",	
				hide: false,
				onTestComplete: onTestComplete
			},	    
			{
				type:  "HEADINGICON",
				value: "../images/iconpixel.png",
				hide:  true,
			},	    
			{
				type: "HEADING",
				text: "Screen display",
				hide:  true
			},
			
		],

	    tailItems:
	    [ 
			{
				type: "QUERY",
				text: "Was the screen free of any spots which did not match " +
				      "the rest of the screen?",
				hide:  true				
			}	    
	    ],

	    navigationItems:
	    [    
			{
				type: "YES",
				onClick: onYesClick,
				hide:  true								
			},
			{
				type: "RETRY",
				onClick: onRetryClick,
				hide:  true								
			},	
			{
				type: "NO",
				onClick: onNoClick,
				hide:  true								
			}	
      	]
	};
	
	function onTestComplete(aTestArea)
	{
		console.log("++ onTestComplete");		

		Workflow.setPageBackground("0xFFFFFF");
		
		var pageItems = Workflow.getPageItems();
		var tailItems = Workflow.getTailItems();
		var navItems  = Workflow.getNavigationItems();

		invertItemVisibility(pageItems);
		invertItemVisibility(tailItems);
		invertItemVisibility(navItems);

		Workflow.setHeaderStyle(true, true);
	}	

	function invertItemVisibility(aItems)
	{
		if (aItems == null)
		{
			return;
		}

		for (var index in aItems)
		{
			var thisItem = aItems[index];			
			var visisble = thisItem.hide;

			Workflow.setVisibility(thisItem, visisble);
		}		
	}

	function onRetryClick()
	{
        var status = JSON.stringify(
        {
            details: Const.CONDITION_CANCELLED_TEXT,
            level:   Const.CONDITION_CANCELLED_LEVEL
        });

		Workflow.setProperty(PROPERTY, status);             

		Workflow.setCurrentPageWithId("test-pixels-check");
	}	

	function onYesClick()
	{
		var status    = { details: TEST_TEXT_PASSED, level: Const.CONDITION_GOOD};
		var statusStr = JSON.stringify(status);

		Workflow.setProperty(PROPERTY, statusStr);

		Workflow.setAppState(MMRSAPPSTATE.EVERGREEN_PHYSICAL_CHECK_GOOD);

		Workflow.popPage();		
	}

	function onNoClick()
	{
		var status    = { details: TEST_TEXT_FAILED, level: Const.CONDITION_MINOR_DAMAGE};
		var statusStr = JSON.stringify(status);

		Workflow.setProperty(PROPERTY, statusStr);

		Workflow.setAppState(MMRSAPPSTATE.EVERGREEN_PHYSICAL_CHECK_BAD);		

		Workflow.popPage();		
	}

</script>

