<script type="workflow-page">
	
	var PROPERTY = Properties.TouchStatus;

	var TEST_TEXT_PASSED = "Touch test passed";
	var TEST_TEXT_FAILED = "Touch test failed";
	
	var QUERY_TEXT = "queryText";

	var mTestArea           = null;
	var mTestCanvas         = null;
	var mTestAreaFullHeight = -1;

	var page =
	{
	    items:
	    [
			{
				type: "TEST_TOUCH",	
				hide: true,
				onTestComplete: onTestComplete
			},
			{
				type:  "HEADINGICON",
				value: "../images/icontouch.png"
			},	    
			{
				type: "HEADING",
				text: "Draw on the screen to test"
			},
			{
				type: "SUBHEADING",
				text: "Use your finger to draw on the screen to test its responsiveness. " +
					  "Lift your finger off the screen once you're done."
			}			
		],

	    tailItems:
	    [
			{
				id:   QUERY_TEXT,
				type: "QUERY",
				text: "Is the screen functioning correctly?",
				hide: true
			}	    
	    ],		

	    navigationItems:
	    [
			{
				type: "TEXT",
				text: "Start",
				onClick: onStartClick
			},	    
			{
				type   : "YES",
				onClick: onYesClick,
				hide   : true
			},
			{
				type: "RETRY",
				onClick: onRetryClick,
				hide   : true				
			},						    
			{
				type: "NO",
				onClick: onNoClick,
				hide   : true
			}					
      	]
	};
	
	function init()
	{
	}	

	function onStartClick()
	{
		var pageItems = Workflow.getPageItems();
		var tailItems = Workflow.getTailItems();
		var navItems  = Workflow.getNavigationItems();

		invertItemVisibility(pageItems);
		invertItemVisibility(tailItems);
		invertItemVisibility(navItems);

		//Workflow.setCurrentPageWithId("test-touch-check");
	}	

	function invertItemVisibility(aItems)
	{
		if (aItems == null)
		{
			return;
		}

		for (var index in aItems)
		{
			var thisItem = aItems[index];			
			var visisble = thisItem.hide;

			Workflow.setVisibility(thisItem, visisble);
		}		
	}

	function onTestComplete(aTestArea, aTestCanvas)
	{
		console.log("++ onTestComplete");

		//Workflow.setHeaderStyle(true, true);

		if (aTestArea == null || aTestCanvas == null)
		{
			console.log("onTestComplete, No test area/canvas passed");
			return;
		}

		if (mTestAreaFullHeight == -1)
		{
			mTestArea           = aTestArea;
			mTestCanvas         = aTestCanvas;
			mTestAreaFullHeight = aTestArea.getBoundingClientRect().height;
		}	

		console.log("onTestComplete, Test Area Full Height: " +mTestAreaFullHeight);

		var tailArea = document.getElementById(QUERY_TEXT);

		if (tailArea == null)
		{
			console.log("onTestComplete, Cannot find tail area");
			return;
		}

    	var tailAreaRect = tailArea.getBoundingClientRect();

    	console.log("Tail Area Top: " +tailAreaRect.top);		

    	var testAreaHeight = tailAreaRect.top;

		aTestArea.style.height = testAreaHeight+ "px";
	}

	function onRetryClick()
	{
        var status = JSON.stringify(
        {
            details: Const.CONDITION_CANCELLED_TEXT,
            level:   Const.CONDITION_CANCELLED_LEVEL
        });

		Workflow.setProperty(PROPERTY, status);     

		const context = mTestCanvas.getContext('2d');

		context.clearRect(0, 0, mTestCanvas.width, mTestCanvas.height);

		mTestArea.style.height = mTestAreaFullHeight+ "px";
	}	

	function onYesClick()
	{
		var status    = { details: TEST_TEXT_PASSED, level: Const.CONDITION_GOOD};
		var statusStr = JSON.stringify(status);

		Workflow.setProperty(PROPERTY, statusStr);
		
		Workflow.popPage();			
	}

	function onNoClick()
	{
		var status    = { details: TEST_TEXT_FAILED, level: Const.CONDITION_MINOR_DAMAGE};
		var statusStr = JSON.stringify(status);

		Workflow.setProperty(PROPERTY, statusStr);

		Workflow.popPage();		
	}
	

</script>

