<script type="workflow-page">

	var mAssessment = null;
	
	var page =
	{
	    items:
	    [    
			{
				type: "HEADING",
				text: "Your lease plan"
			},
			{
				type: "SUBHEADING",
				text: getContractText()
			},
			{
				type:    "FAQ",
				items:   getFAQItems(),
				match:   getFAQMatches(),			
				onClick: onFAQClick						
			},			
			{
				type: "SUBHEADING",
				text: "You can upgrade to a new device when you take up a new 24 month plan, and pay</B>:"
			},
			{
				type: "PRICE",
				text: "$" +getSwapPrice()+ "*"
			},
			{
				type: "SUBHEADING",
				text: "*This fee is based on the condition of your device when it was tested, on " +
					  getAssessmentDate() + ". "
			},
			{
				type: "TEXT",				
				text: "Has the condition of your device changed since your last test? " +
				      "[#Retest your device now#]",
				onClick: onRetestClick				      
			}			
		],

	    navigationItems:
	    [
			{
				type: "TEXT",
				text: "How to upgrade",
				onClick: onNextClick,
			}	
      	]
	};
	
	function init()
	{
		console.log(">> init");
	}	 

	function getContractText()
	{
		var onAssure = Workflow.getProperty(Properties.accountOnAssurePlan) == "true";

		var text = "You started leasing this device, under a <B>Mobile Lease Plan</B>, on ";

		if (onAssure)
		{
			text = "You started leasing this device, under a <B>Mobile Lease Plan</B> " +
			       " with <B>Mobile Swap Assure</B>, on ";
		}

		text += "<B>" +getContractStartDate()+ "</B>.";

		return text;
	}


	function getContractStartDate()
	{
		console.log(">> getContractStartDate");

		var contractTime = Workflow.getProperty(Properties.accountContractStartDate);
		
		var contractDate = new Date(contractTime*1000);

		var contractStr  = WorkflowUtils.makeShortDateString(contractDate);

		return contractStr;		
	}

	function getSwapPrice()
	{
		retrieveAssessment();

		var swapPrice = mAssessment.swapPrice;

		return swapPrice;
	}

	function getAssessmentDate()
	{
		retrieveAssessment();

		var date = new Date(mAssessment.created);

		var dateStr  = WorkflowUtils.makeShortDateString(date);

		return dateStr;
	}

	function getFAQItems()
	{
		var faqsString = Workflow.readValue("swap-faqs");

		var faqs = null;

		try
		{
			faqs = JSON.parse(faqsString);
		}
		catch (err)
		{
			console.error("getFAQItems, Could not parse FAQS: " +err);
		}

		return faqs;		
	}

	function getFAQMatches()
	{
		var onAssure = Workflow.getProperty(Properties.accountOnAssurePlan) == "true";
		
		var match = onAssure ? ["MOBILE_SWAP_ASSURE"] : null;

		return match;
	}		

	function retrieveAssessment()
	{
		console.log(">> retrieveAssessment");

		if (mAssessment != null)
		{
			console.log("<< retrieveAssessment, Already got assessment");
			return;
		}

        var assessmentStr = Workflow.readValue(Properties.UserReportSwapAssessment);

        console.log("retrieveAssessment, Assessment: " +assessmentStr);

        if (assessmentStr == null || assessmentStr == "")
        {
        	console.log("retrieveAssessment, No user Assessment recorded");  
        	mAssessment = {};      	
        	return;
        }

        mAssessment = JSON.parse(assessmentStr);

        var swapPrice = mAssessment.swapPrice;

        if (swapPrice != null)
        {
	        Workflow.setProperty(Properties.SwapPrice, swapPrice);
        }

		console.log("<< retrieveAssessment, Got assessment");
	}

	function onNextClick()
	{
		Workflow.setCurrentPageWithId("swap-howto");		
	}

	function onFAQClick(aItem, aExpanded, aHeaderId)
	{
		console.log("onFAQClick, Item: " +aItem.id+ ", Header: " +aHeaderId);	

		if (!aExpanded)
		{
			return;
		}

		WorkflowUtils.scrollTo(aHeaderId);
	}		

	function onRetestClick()
	{
		console.log("onRetestClick");
		
		Workflow.setCurrentPageWithId("swap-year2");		
	}

</script>

