var WORKFLOWPAYLOAD = (function ()
{
    "use strict";

        var BRIDGE = MMRSUTILS.getDeviceBridge();

        var mWorkflowConstants = null;
        var mWorkflowFields    = null;  

        function init(aNames)
        {
            trace("init, Names: " +aNames);

            mWorkflowConstants = aNames.constants;
            mWorkflowFields    = aNames.fields;
        }

        function bodyDamage(aProperties)
        {
            switch (aProperties[mWorkflowFields.deviceConditionCase])
            {
                case mWorkflowConstants.CONDITION_GOOD:
                    return "As new";

                case mWorkflowConstants.CONDITION_MINOR_DAMAGE:
                    return "General wear & tear";

                case mWorkflowConstants.CONDITION_MAJOR_DAMAGE:
                    return "Damaged";

                default:
                    throw "Invalid body damage: " + aProperties[mWorkflowFields.deviceConditionCase];
            }
        }

        function screenCondition(aProperties)
        {
            if (aProperties[mWorkflowFields.deviceConditionScreen] === mWorkflowConstants.CONDITION_GOOD)
                return "No cracks";
            else
                return "Cracks";
        }

        function liquidDamage(aProperties)
        {
            if (aProperties[mWorkflowFields.deviceConditionLiquid] === mWorkflowConstants.CONDITION_GOOD)
                return "No liquid damage";
            else
                return "Liquid damage";
        }

        function isDamaged(aProperties)
        {
            return aProperties[mWorkflowFields.deviceConditionCase] !== mWorkflowConstants.CONDITION_GOOD
                    || aProperties[mWorkflowFields.deviceConditionScreen] !== mWorkflowConstants.CONDITION_GOOD
                    || aProperties[mWorkflowFields.deviceConditionLiquid] !== mWorkflowConstants.CONDITION_GOOD;
            // TODO: isDamaged = true if pixel or touch tests fail?
        }


    function initCreateAssessmentReport() 
    {
        var dateNow = new Date();

        var payload = {};

        //payload.token               = 

        payload.msisdn              = null;
        payload.imei                = null;
        payload.created             = dateNow.toISOString();
        
        payload.source              = null;         // TDC App or TDC Portal
        payload.isImeiMatch         = null;         // "true" or "false"
        payload.powerOn             = "Yes";
        payload.deviceCondition     = null;         // 0 - Good, 1 - Major Damage, 2 - Minor, 3 - Lost/Stolen
        payload.liquidDamage        = null;         // Yes or No        
        payload.deviceLock          = null;         // Active or Non-Active
        
        //payload.deviceLeftInStore   =   
        //payload.deviceCapacity      = 
        
        //payload.planStartDate       = undefined;
        //payload.planEndDate         = undefined;
        
        payload.assure              = null;         // Y or N
        
        //payload.ran                 = undefined;
        //payload.redemptionCode      = undefined;
        //payload.redemptionProcessed = undefined;

        payload.transactionType     = "Redemption or Return";
        payload.deviceLostOrStolen  = "No";
        
        payload.deviceOs            =  null;
        payload.deviceFreeOfLocks   =  null;
        payload.isImeiValid         =  null; 

        //payload.aux1                =  
        //payload.aux2                =        
        //payload.aux3                =  
        //payload.aux4                =  
        //payload.aux5                =  

        return payload;
    }


    // 
    //====================================================================================
    //====================================================================================
    var exports = {};

    exports.name = "workflow-payload";

    function trace(aText) { MMRSUTILS.doTrace(exports.name, aText); }
    function note(aText)  { MMRSUTILS.doTrace(exports.name, aText); }
    function warn(aText)  { MMRSUTILS.doWarn (exports.name, aText); }
    function error(aText) { MMRSUTILS.doError(exports.name, aText); }          

    exports.init = function(aNames) { return init(aNames); }

    exports.initCreateAssessmentReport = function() { return initCreateAssessmentReport(); }

    return exports;



}());
